/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.4 Revision 1.108
1# Copyright 2007-2008 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.4 2008/03/10 21:41:56 zlin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.108 2011/10/06 14:13:29 alexxy Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.0 ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 monolithic ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible, 13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses. 14# over time as new EAPI versions are approved.
15 15
16inherit base eutils multilib cmake-utils kde4-functions 16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual}
17 22
23inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
24
25if [[ ${BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in
27 svn) inherit subversion ;;
28 git) inherit git-2 ;;
29 esac
30fi
31
32# @ECLASS-VARIABLE: CMAKE_REQUIRED
33# @DESCRIPTION:
34# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
35# Please note that if it's set to 'never' you need to explicitly override following phases:
36# src_configure, src_compile, src_test and src_install.
37# Defaults to 'always'.
38: ${CMAKE_REQUIRED:=always}
39if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install"
42fi
43
44# @ECLASS-VARIABLE: KDE_MINIMAL
45# @DESCRIPTION:
46# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
47# version for apps to work. Currently defaults to 4.4
48# One may override this variable to raise version requirements.
49# Note that it is fixed to ${PV} for kde-base packages.
50KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
51
52# Set slot for KDEBASE known packages
53case ${KDEBASE} in
54 kde-base)
55 SLOT=4
56 KDE_MINIMAL="${PV}"
57 ;;
58 koffice)
59 SLOT="2"
60 ;;
61 kdevelop)
62 if [[ ${BUILD_TYPE} = live ]]; then
63 # @ECLASS-VARIABLE: KDEVELOP_VERSION
64 # @DESCRIPTION:
65 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
66 # Applies to KDEBASE=kdevelop only.
67 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
68 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
69 # @DESCRIPTION:
70 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
71 # Applies to KDEBASE=kdevelop only.
72 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
73 else
74 case ${PN} in
75 kdevelop|quanta)
76 KDEVELOP_VERSION=${PV}
77 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
78 ;;
79 kdevplatform)
80 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
81 KDEVPLATFORM_VERSION=${PV}
82 ;;
83 *)
84 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
85 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
86 esac
87 fi
88 SLOT="4"
89 ;;
90esac
91
92inherit ${buildsystem_eclass}
93
18EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 94EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
19 95
20COMMONDEPEND="|| ( ( 96unset buildsystem_eclass
21 x11-libs/qt-core:4 97unset export_fns
22 x11-libs/qt-gui:4 98
23 x11-libs/qt-qt3support:4 99# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
24 x11-libs/qt-svg:4 100# @DESCRIPTION:
25 x11-libs/qt-test:4 ) 101# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
26 >=x11-libs/qt-4.3.3:4 )" 102# This variable must be set before inheriting any eclasses. Defaults to 'never'.
103DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
104
105# @ECLASS-VARIABLE: QTHELP_REQUIRED
106# @DESCRIPTION:
107# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
108# This variable must be set before inheriting any eclasses. Defaults to 'never'.
109QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
27 110
28# @ECLASS-VARIABLE: OPENGL_REQUIRED 111# @ECLASS-VARIABLE: OPENGL_REQUIRED
29# @DESCRIPTION: 112# @DESCRIPTION:
30# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 113# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
31# This variable must be set before inheriting any eclasses. Defaults to 'never'. 114# This variable must be set before inheriting any eclasses. Defaults to 'never'.
32OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 115OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
33 116
34OPENGLDEPEND="|| ( x11-libs/qt-opengl:4 117# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
35 >=x11-libs/qt-4.3.3:4 )" 118# @DESCRIPTION:
36case "${OPENGL_REQUIRED}" in 119# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
37 always) 120# This variable must be set before inheriting any eclasses. Defaults to 'never'.
38 COMMONDEPEND="${COMMONDEPEND} 121MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
39 ${OPENGLDEPEND}"
40 ;;
41 optional)
42 IUSE="${IUSE} opengl"
43 COMMONDEPEND="${COMMONDEPEND}
44 opengl? ( ${OPENGLDEPEND} )"
45 ;;
46 *)
47 OPENGL_REQUIRED="never"
48 ;;
49esac
50
51DEPEND="${DEPEND} ${COMMONDEPEND}
52 >=dev-util/cmake-2.4.7-r1
53 dev-util/pkgconfig
54 x11-libs/libXt
55 x11-proto/xf86vidmodeproto"
56RDEPEND="${RDEPEND} ${COMMONDEPEND}"
57 122
58# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 123# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
59# @DESCRIPTION: 124# @DESCRIPTION:
60# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 125# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
61# This variable must be set before inheriting any eclasses. Defaults to 'never'. 126# This variable must be set before inheriting any eclasses. Defaults to 'never'.
62CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}" 127CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
63 128
64case "${CPPUNIT_REQUIRED}" in 129# @ECLASS-VARIABLE: KDE_REQUIRED
130# @DESCRIPTION:
131# Is kde required? Possible values are 'always', 'optional' and 'never'.
132# This variable must be set before inheriting any eclasses. Defaults to 'always'
133# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
134# Note that for kde-base packages this variable is fixed to 'always'.
135KDE_REQUIRED="${KDE_REQUIRED:-always}"
136
137# @ECLASS-VARIABLE: KDE_HANDBOOK
138# @DESCRIPTION:
139# Set to enable handbook in application. Possible values are 'always', 'optional'
140# (handbook USE flag) and 'never'.
141# This variable must be set before inheriting any eclasses. Defaults to 'never'.
142# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
143# ensures buildtime and runtime dependencies.
144KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
145
146# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
147# @DESCRIPTION:
148# Set this varible if you want your live package to manage its
149# translations. (Mostly all kde ebuilds does not ship documentation
150# and translations in live ebuilds)
151if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
152 # Kdebase actualy provides the handbooks even for live stuff
153 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
154 KDE_LINGUAS=""
155fi
156
157# Setup packages inheriting this eclass
158case ${KDEBASE} in
159 kde-base)
160 HOMEPAGE="http://www.kde.org/"
161 LICENSE="GPL-2"
162 if [[ $BUILD_TYPE = live ]]; then
163 # Disable tests for live ebuilds
164 RESTRICT+=" test"
165 fi
166
167 # Only add the kdeprefix USE flag for older versions, to help
168 # non-portage package managers handle the upgrade
169 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
170 IUSE+=" kdeprefix"
171 fi
172
173 # This code is to prevent portage from searching GENTOO_MIRRORS for
174 # packages that will never be mirrored. (As they only will ever be in
175 # the overlay).
176 case ${PV} in
177 *9999* | 4.?.[6-9]?)
178 RESTRICT+=" mirror"
179 ;;
180 esac
181 ;;
182 koffice)
183 HOMEPAGE="http://www.koffice.org/"
184 LICENSE="GPL-2"
185 ;;
186 kdevelop)
187 HOMEPAGE="http://www.kdevelop.org/"
188 LICENSE="GPL-2"
189 ;;
190esac
191
192# @ECLASS-VARIABLE: QT_MINIMAL
193# @DESCRIPTION:
194# Determine version of qt we enforce as minimal for the package.
195if version_is_at_least 4.5.50 "${KDE_MINIMAL}"; then
196 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
197else
198 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
199fi
200
201# Declarative dependencies
202qtdeclarativedepend="
203 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
204"
205case ${DECLARATIVE_REQUIRED} in
65 always) 206 always)
66 DEPEND="${DEPEND} dev-util/cppunit" 207 COMMONDEPEND+=" ${qtdeclarativedepend}"
67 ;; 208 ;;
68 optional) 209 optional)
69 IUSE="${IUSE} test" 210 IUSE+=" declarative"
70 DEPEND="${DEPEND} 211 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
71 test? ( dev-util/cppunit )"
72 ;; 212 ;;
73 *) 213 *) ;;
74 CPPUNIT_REQUIRED="never" 214esac
215unset qtdeclarativedepend
216
217# QtHelp dependencies
218qthelpdepend="
219 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
220"
221case ${QTHELP_REQUIRED} in
222 always)
223 COMMONDEPEND+=" ${qthelpdepend}"
75 ;; 224 ;;
225 optional)
226 IUSE+=" qthelp"
227 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
228 ;;
76esac 229esac
230unset qthelpdepend
77 231
78# @ECLASS-VARIABLE: NEED_KDE 232# OpenGL dependencies
233qtopengldepend="
234 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
235"
236case ${OPENGL_REQUIRED} in
237 always)
238 COMMONDEPEND+=" ${qtopengldepend}"
239 ;;
240 optional)
241 IUSE+=" opengl"
242 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
243 ;;
244 *) ;;
245esac
246unset qtopengldepend
247
248# MultiMedia dependencies
249qtmultimediadepend="
250 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
251"
252case ${MULTIMEDIA_REQUIRED} in
253 always)
254 COMMONDEPEND+=" ${qtmultimediadepend}"
255 ;;
256 optional)
257 IUSE+=" multimedia"
258 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
259 ;;
260 *) ;;
261esac
262unset qtmultimediadepend
263
264# CppUnit dependencies
265cppuintdepend="
266 dev-util/cppunit
267"
268case ${CPPUNIT_REQUIRED} in
269 always)
270 DEPEND+=" ${cppuintdepend}"
271 ;;
272 optional)
273 IUSE+=" test"
274 DEPEND+=" test? ( ${cppuintdepend} )"
275 ;;
276 *) ;;
277esac
278unset cppuintdepend
279
280
281# WebKit use dependencies
282case ${KDE_REQUIRED} in
283 always)
284 qtwebkitusedeps="[kde]"
285 ;;
286 optional)
287 qtwebkitusedeps="[kde?]"
288 ;;
289 *) ;;
290esac
291# KDE dependencies
292# Qt accessibility classes are needed in various places, bug 325461
293kdecommondepend="
294 dev-lang/perl
295 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
296 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
297 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
298 >=x11-libs/qt-script-${QT_MINIMAL}:4
299 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
300 >=x11-libs/qt-svg-${QT_MINIMAL}:4
301 >=x11-libs/qt-test-${QT_MINIMAL}:4
302 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
303 !aqua? (
304 x11-libs/libXext
305 x11-libs/libXt
306 x11-libs/libXxf86vm
307 x11-libs/libXcomposite
308 x11-libs/libxkbfile
309 )
310"
311
312if [[ ${PN} != kdelibs ]]; then
313 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
314 if [[ ${KDEBASE} = kdevelop ]]; then
315 if [[ ${PN} != kdevplatform ]]; then
316 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
79# @DESCRIPTION: 317 # @DESCRIPTION:
80# This variable sets the version of KDE4 which will be used by the eclass. 318 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
81# This variable must be set by the ebuild, for all categories except for "kde-base". 319 # Applies to KDEBASE=kdevelop only.
82# For kde-base packages, if it is not set by the ebuild, 320 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
83# it's assumed that the required KDE4 version is the latest, non-live, available. 321 case ${KDEVPLATFORM_REQUIRED} in
84# 322 always)
85# @CODE 323 kdecommondepend+="
86# Acceptable values are: 324 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
87# - latest - Use latest version in the portage tree 325 "
88# Default for kde-base ebuilds. Banned for ebuilds not part of kde or koffice. 326 ;;
89# - svn - Use svn release (live ebuilds) 327 *) ;;
90# - :SLOT - Use any version in the SLOT specified in the NEED_KDE value. 328 esac
91# - VERSION_NUMBER - Use the minimum KDE4 version specified in the NEED_KDE value. 329 fi
92# - VERSION_NUMBER:SLOT - Use the minimum KDE4 version and the SLOT specified in the NEED_KDE value.
93# - none - Let the ebuild handle SLOT, kde dependencies, KDEDIR, ...
94# @CODE
95#
96# Note: There is no default NEED_KDE for ebuilds not in kde-base or part of
97# koffice, so you must set it explicitly in the ebuild, in all other cases.
98if [[ -z ${NEED_KDE} ]]; then
99 if [[ -n ${KDEBASE} ]]; then
100 NEED_KDE="latest"
101 else
102 die "kde4-base.eclass inherited but NEED_KDE not defined - broken ebuild"
103 fi 330 fi
104fi 331fi
105export NEED_KDE
106 332
107case ${NEED_KDE} in 333kdedepend="
108 latest) 334 dev-util/automoc
109 # Should only be used by 'kde-base'-ebuilds 335 dev-util/pkgconfig
110 if [[ "${KDEBASE}" == "kde-base" ]]; then 336 !aqua? (
111 case ${PV} in 337 >=x11-libs/libXtst-1.1.0
112 3.9*) _kdedir="3.9" ;; 338 x11-proto/xf86vidmodeproto
113 4*) _kdedir="4.0" ;; 339 )
114 *) die "NEED_KDE=latest not supported for PV=${PV}" ;; 340"
115 esac
116 _operator=">="
117 _pv="-${PV}:kde-4"
118 else
119 _kdedir="4.0"
120 _pv=":kde-4"
121 fi
122 ;;
123 svn|9999*|:kde-svn)
124 _kdedir="svn"
125 _pv=":kde-svn"
126 export NEED_KDE="svn"
127 ;;
128 *:kde-svn)
129 _kdedir="svn"
130 _operator=">="
131 _pv="-${NEED_KDE}"
132 export NEED_KDE="svn"
133 ;;
134 # The ebuild handles dependencies, KDEDIR, SLOT.
135 none)
136 :
137 ;;
138 # NEED_KDE=":${SLOT}"
139 :kde-4)
140 _kdedir="4.0"
141 _pv="${NEED_KDE}"
142 ;;
143 # NEED_KDE="${PV}:${SLOT}"
144 *:kde-4)
145 _kdedir="4.0"
146 _operator=">="
147 _pv="-${NEED_KDE}"
148 ;;
149 3.9*)
150 _kdedir="3.9"
151 _operator=">="
152 _pv="-${NEED_KDE}:kde-4"
153 ;;
154 4*)
155 _kdedir="4.0"
156 _operator=">="
157 _pv="-${NEED_KDE}:kde-4"
158 ;;
159 *) die "NEED_KDE=${NEED_KDE} currently not supported."
160 ;;
161esac
162 341
163if [[ ${NEED_KDE} != none ]]; then 342kderdepend=""
164 KDEDIR="/usr/kde/${_kdedir}"
165 KDEDIRS="/usr:/usr/local:${KDEDIR}"
166 343
167 if [[ -n ${KDEBASE} ]]; then 344# all packages needs oxygen icons for basic iconset
168 if [[ ${NEED_KDE} = svn ]]; then
169 SLOT="kde-svn"
170 else
171 SLOT="kde-4"
172 fi
173 fi
174
175 # We only need to add the dependencies if ${PN} is not "kdelibs" or "kdepimlibs"
176 if [[ ${PN} != "kdelibs" ]]; then 345if [[ ${PN} != oxygen-icons ]]; then
177 DEPEND="${DEPEND} 346 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
178 ${_operator}kde-base/kdelibs${_pv}"
179 RDEPEND="${RDEPEND}
180 ${_operator}kde-base/kdelibs${_pv}"
181 if [[ ${PN} != "kdepimlibs" ]]; then
182 DEPEND="${DEPEND}
183 ${_operator}kde-base/kdepimlibs${_pv}"
184 RDEPEND="${RDEPEND}
185 ${_operator}kde-base/kdepimlibs${_pv}"
186 fi
187 fi
188
189 unset _operator _pv _kdedir
190fi 347fi
348
349# add a dependency over kde-l10n if EAPI4 or better is around
350if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
351 for _lingua in ${KDE_LINGUAS}; do
352 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
353 # but only for selected ones.
354 # this can't be done on one line because if user doesn't use any localisation
355 # then he is probably not interested in kde-l10n at all.
356 kderdepend+="
357 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
358 "
359 done
360 unset _lingua
361fi
362
363kdehandbookdepend="
364 app-text/docbook-xml-dtd:4.2
365 app-text/docbook-xsl-stylesheets
366"
367kdehandbookrdepend="
368 $(add_kdebase_dep kdelibs 'handbook')
369"
370case ${KDE_HANDBOOK} in
371 always)
372 kdedepend+=" ${kdehandbookdepend}"
373 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
374 ;;
375 optional)
376 IUSE+=" +handbook"
377 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
378 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
379 ;;
380 *) ;;
381esac
382unset kdehandbookdepend kdehandbookrdepend
383
384case ${KDE_REQUIRED} in
385 always)
386 IUSE+=" aqua"
387 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
388 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
389 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
390 ;;
391 optional)
392 IUSE+=" aqua kde"
393 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
394 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
395 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
396 ;;
397 *) ;;
398esac
399
400unset kdecommondepend kdedepend kderdepend
401
402debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
403debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
404debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
405
406# Accumulate dependencies set by this eclass
407DEPEND+=" ${COMMONDEPEND}"
408RDEPEND+=" ${COMMONDEPEND}"
409unset COMMONDEPEND
410
411# Add experimental kdeenablefinal, masked by default
412IUSE+=" kdeenablefinal"
191 413
192# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 414# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
193# koffice ebuild, the URI should be set in the ebuild itself 415# koffice ebuild, the URI should be set in the ebuild itself
194if [[ -n ${KDEBASE} ]]; then 416_calculate_src_uri() {
417 debug-print-function ${FUNCNAME} "$@"
418
419 local _kmname _kmname_pv
420
421 # we calculate URI only for known KDEBASE modules
422 [[ -n ${KDEBASE} ]] || return
423
424 # calculate tarball module name
195 if [[ -n ${KMNAME} ]]; then 425 if [[ -n ${KMNAME} ]]; then
426 # fixup kdebase-apps name
427 case ${KMNAME} in
428 kdebase-apps)
429 _kmname="kdebase" ;;
430 *)
196 _kmname=${KMNAME} 431 _kmname="${KMNAME}" ;;
432 esac
197 else 433 else
198 _kmname=${PN} 434 _kmname=${PN}
199 fi 435 fi
200 _kmname_pv="${_kmname}-${PV}" 436 _kmname_pv="${_kmname}-${PV}"
201 if [[ ${NEED_KDE} != "svn" ]]; then
202 case ${KDEBASE} in 437 case ${KDEBASE} in
203 kde-base) 438 kde-base)
204 case ${PV} in 439 case ${PV} in
440 4.[456].8[05] | 4.[456].9[023568])
441 # Unstable KDE SC releases
442 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
443 if ! version_is_at_least 4.6.80 ${PV}
444 then
445 # KDEPIM IS SPECIAL
446 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
447 fi
448 ;;
449 *)
450 # Stable KDE SC releases
205 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2";; 451 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
452 if ! version_is_at_least 4.6.80 ${PV}
453 then
454 # KDEPIM IS SPECIAL
455 # TODO: It might not be with KDE 4.7 (see above)
456 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
457 fi
458 ;;
206 esac 459 esac
207 ;; 460 ;;
208 koffice) 461 koffice)
462 case ${PV} in
463 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
209 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" 464 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
465 esac
210 ;; 466 ;;
467 kdevelop)
468 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
469 ;;
470 esac
471}
472
473_calculate_live_repo() {
474 debug-print-function ${FUNCNAME} "$@"
475
476 SRC_URI=""
477 case ${KDE_SCM} in
478 svn)
479 # Determine branch URL based on live type
480 local branch_prefix
481 case ${PV} in
482 9999*)
483 # trunk
484 branch_prefix="trunk/KDE"
485 ;;
486 *)
487 # branch
488 branch_prefix="branches/KDE/$(get_kde_version)"
489 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
490 # @DESCRIPTION
491 # Suffix appended to ESVN_PROJECT depending on fetched branch.
492 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
493 ESVN_PROJECT_SUFFIX="-${PV}"
494 ;;
495 esac
496 # @ECLASS-VARIABLE: ESVN_MIRROR
497 # @DESCRIPTION:
498 # This variable allows easy overriding of default kde mirror service
499 # (anonsvn) with anything else you might want to use.
500 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
501 # Split ebuild, or extragear stuff
502 if [[ -n ${KMNAME} ]]; then
503 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
504 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
505 KMMODULE="${PN}"
506 fi
507 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
508 case ${KMNAME} in
509 kdebase-*)
510 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
511 ;;
512 kdelibs-*)
513 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
514 ;;
515 kdereview*)
516 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
517 ;;
518 kdesupport)
519 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
520 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
521 ;;
522 kde*)
523 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
524 ;;
525 extragear*|playground*)
526 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
527 # build packages from same svn location.
528 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
529 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
530 ;;
531 koffice)
532 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
533 ;;
534 *)
535 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
536 ;;
537 esac
538 else
539 # kdelibs, kdepimlibs
540 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
541 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
542 fi
543 # @ECLASS-VARIABLE: ESVN_UP_FREQ
544 # @DESCRIPTION:
545 # This variable is used for specifying the timeout between svn synces
546 # for kde-base and koffice modules. Does not affect misc apps.
547 # Default value is 1 hour.
548 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
549 ;;
550 git)
551 local _kmname
552 # @ECLASS-VARIABLE: EGIT_MIRROR
553 # @DESCRIPTION:
554 # This variable allows easy overriding of default kde mirror service
555 # (anongit) with anything else you might want to use.
556 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
557
558 # @ECLASS-VARIABLE: EGIT_REPONAME
559 # @DESCRIPTION:
560 # This variable allows overriding of default repository
561 # name. Specify only if this differ from PN and KMNAME.
562 if [[ -n ${EGIT_REPONAME} ]]; then
563 # the repository and kmname different
564 _kmname=${EGIT_REPONAME}
565 elif [[ -n ${KMNAME} ]]; then
566 _kmname=${KMNAME}
567 else
568 _kmname=${PN}
569 fi
570
571 # default branching
572 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
573 EGIT_BRANCH="KDE/$(get_kde_version)"
574
575 # default repo uri
576 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
577
578 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
579 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
580 ;;
581 esac
582}
583
584case ${BUILD_TYPE} in
585 live) _calculate_live_repo ;;
586 *) _calculate_src_uri ;;
587esac
588
589debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
590
591# @ECLASS-VARIABLE: PREFIX
592# @DESCRIPTION:
593# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
594# kde-base packages go into KDE4 installation directory (/usr).
595# No matter the PREFIX, package will be built against KDE installed in /usr.
596
597# @FUNCTION: kde4-base_pkg_setup
598# @DESCRIPTION:
599# Do some basic settings
600kde4-base_pkg_setup() {
601 debug-print-function ${FUNCNAME} "$@"
602
603 if has kdeprefix ${IUSE//+} && use kdeprefix; then
604 eerror "Sorry, kdeprefix support has been removed."
605 eerror "Please remove kdeprefix from your USE variable."
606 die "kdeprefix support has been removed"
607 fi
608
609 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
610 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
611 has_version kde-base/kdelibs[kdeprefix]; then
612 eerror "Sorry, kdeprefix support has been removed."
613 eerror "Please rebuild kdelibs without kdeprefix support."
614 die "kdeprefix support has been removed"
615 fi
616
617 # Don't set KDEHOME during compilation, it will cause access violations
618 unset KDEHOME
619
620 # Check if gcc compiler is fresh enough.
621 # In theory should be in pkg_pretend but we check it only for kdelibs there
622 # and for others we do just quick scan in pkg_setup because pkg_pretend
623 # executions consume quite some time.
624 if [[ ${MERGE_TYPE} != binary ]]; then
625 [[ $(gcc-major-version) -lt 4 ]] || \
626 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
627 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
628 fi
629
630 KDEDIR=/usr
631 : ${PREFIX:=/usr}
632 EKDEDIR=${EPREFIX}/usr
633
634 # Point to correct QT plugins path
635 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
636
637 # Fix XDG collision with sandbox
638 export XDG_CONFIG_HOME="${T}"
639}
640
641# @FUNCTION: kde4-base_src_unpack
642# @DESCRIPTION:
643# This function unpacks the source tarballs for KDE4 applications.
644kde4-base_src_unpack() {
645 debug-print-function ${FUNCNAME} "$@"
646
647 if [[ ${BUILD_TYPE} = live ]]; then
648 case ${KDE_SCM} in
649 svn)
650 migrate_store_dir
651 subversion_src_unpack
652 ;;
653 git)
654 git-2_src_unpack
655 ;;
211 esac 656 esac
212 fi
213 unset _kmname _kmname_pv
214fi
215
216debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
217debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - before blockers"
218
219# Monolithic ebuilds should add blockers for split ebuilds in the same slot.
220# If KMNAME is not set then this is not a split package
221if [[ -n ${KDEBASE} && -z ${KMNAME} ]]; then
222 for _x in $(get-child-packages ${CATEGORY}/${PN}); do
223 DEPEND="${DEPEND} !${_x}:${SLOT}"
224 RDEPEND="${RDEPEND} !${_x}:${SLOT}"
225 done
226 unset _x
227fi
228
229debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND ${DEPEND} - after blockers"
230
231# @ECLASS-VARIABLE: PREFIX
232# @DESCRIPTION:
233# Set the installation PREFIX. All kde-base ebuilds go into the KDE4 installation directory.
234# Applications installed by the other ebuilds go into /usr/ by default, this value
235# can be superseded by defining PREFIX before inheriting kde4-base.
236if [[ -n ${KDEBASE} ]]; then
237 PREFIX=${KDEDIR}
238else
239 # if PREFIX is not defined we set it to the default value of /usr
240 PREFIX="${PREFIX:-/usr}"
241fi
242
243debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SLOT ${SLOT} - KDEDIR ${KDEDIR} - KDEDIRS ${KDEDIRS}- PREFIX ${PREFIX} - NEED_KDE ${NEED_KDE}"
244
245# @FUNCTION: kde4-base_pkg_setup
246# @DESCRIPTION:
247# Adds flags needed by all of KDE 4 to $QT4_BUILT_WITH_USE_CHECK. Uses
248# kde4-functions_check_use from kde4-functions.eclass to print appropriate
249# errors and die if any required flags listed in $QT4_BUILT_WITH_USE_CHECK or
250# $KDE4_BUILT_WITH_USE_CHECK are missing.
251kde4-base_pkg_setup() {
252 debug-print-function $FUNCNAME "$@"
253
254 # KDE4 applications require qt4 compiled with USE="accessibility dbus gif jpeg png qt3support ssl zlib".
255 if has_version '<x11-libs/qt-4.4_alpha:4'; then
256 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} accessibility dbus gif jpeg png qt3support ssl zlib"
257 else 657 else
258 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 658 unpack ${A}
259 x11-libs/qt-core qt3support ssl 659 fi
260 x11-libs/qt-gui accessibility dbus 660}
261 x11-libs/qt-qt3support accessibility" 661
662# @FUNCTION: kde4-base_src_prepare
663# @DESCRIPTION:
664# General pre-configure and pre-compile function for KDE4 applications.
665# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
666# enable_selected_linguas() and enable_selected_doc_linguas()
667# in kde4-functions.eclass(5) for further details.
668kde4-base_src_prepare() {
669 debug-print-function ${FUNCNAME} "$@"
670
671 # enable handbook and linguas only when not using live ebuild
672
673 # Only enable selected languages, used for KDE extragear apps.
674 if [[ -n ${KDE_LINGUAS} ]]; then
675 enable_selected_linguas
676 fi
677
678 # Enable/disable handbooks for kde4-base packages
679 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
680 # kdelibs inherits kde4-base but handle installing the handbook itself
681 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then
682 if [[ ${KDEBASE} == kde-base ]]; then
683 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
684 # documentation in kde4-functions
685 : ${KDE_DOC_DIRS:=doc}
686 local dir
687 for dir in ${KDE_DOC_DIRS}; do
688 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
689 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
690 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
691 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
692 -i CMakeLists.txt || die "failed to comment out handbook"
693 done
694 fi
695 else
696 enable_selected_doc_linguas
697 fi
698 fi
699
700 # SCM bootstrap
701 if [[ ${BUILD_TYPE} = live ]]; then
702 case ${KDE_SCM} in
703 svn) subversion_src_prepare ;;
704 esac
705 fi
706
707 # Apply patches
708 base_src_prepare
709
710 # Save library dependencies
711 if [[ -n ${KMSAVELIBS} ]] ; then
712 save_library_dependencies
713 fi
714
715 # Inject library dependencies
716 if [[ -n ${KMLOADLIBS} ]] ; then
717 load_library_dependencies
718 fi
719
720 # Replace KDE4Workspace library targets
721 find "${S}" -name CMakeLists.txt \
722 -exec sed -i -r \
723 -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' \
724 -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' \
725 -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' \
726 -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' \
727 -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' \
728 -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' \
729 -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' \
730 -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' \
731 -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' \
732 -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' \
733 -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' \
734 -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' \
735 -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' \
736 -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' \
737 -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' \
738 {} + \
739 || die 'failed to replace KDE4Workspace library targets'
740
741 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
742 if [[ -z ${KDEBASE} ]]; then
743 find "${S}" -name "*.docbook" \
744 -exec sed -i -r \
745 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
746 || die 'failed to fix DocBook variant version'
747 fi
748}
749
750# @FUNCTION: kde4-base_src_configure
751# @DESCRIPTION:
752# Function for configuring the build of KDE4 applications.
753kde4-base_src_configure() {
754 debug-print-function ${FUNCNAME} "$@"
755
756 # Build tests in src_test only, where we override this value
757 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
758
759 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
760 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
262 fi 761 fi
263 762
264 if has debug ${IUSE//+} && use debug; then 763 if has debug ${IUSE//+} && use debug; then
265 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then 764 # Set "real" debug mode
266 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} debug" 765 CMAKE_BUILD_TYPE="Debugfull"
766 else
767 # Handle common release builds
768 append-cppflags -DQT_NO_DEBUG
769 fi
770
771 # Set distribution name
772 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
773
774 # Here we set the install prefix
775 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
776
777 # Use colors
778 QTEST_COLORED=1
779
780 # Shadow existing installations
781 unset KDEDIRS
782
783 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
784 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
785 #kde-config -path data unavailable when cross-compiling
786 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
787
788 # sysconf needs to be /etc, not /usr/etc
789 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
790
791 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
792 mycmakeargs=(${mycmakeargs})
793 fi
794
795 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
796
797 cmake-utils_src_configure
798}
799
800# @FUNCTION: kde4-base_src_compile
801# @DESCRIPTION:
802# General function for compiling KDE4 applications.
803kde4-base_src_compile() {
804 debug-print-function ${FUNCNAME} "$@"
805
806 cmake-utils_src_compile "$@"
807}
808
809# @FUNCTION: kde4-base_src_test
810# @DESCRIPTION:
811# Function for testing KDE4 applications.
812kde4-base_src_test() {
813 debug-print-function ${FUNCNAME} "$@"
814
815 # Override this value, set in kde4-base_src_configure()
816 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
817 cmake-utils_src_configure
818 kde4-base_src_compile
819
820 # When run as normal user during ebuild development with the ebuild command, the
821 # kde tests tend to access the session DBUS. This however is not possible in a real
822 # emerge or on the tinderbox.
823 # > make sure it does not happen, so bad tests can be recognized and disabled
824 unset DBUS_SESSION_BUS_ADDRESS
825
826 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
827 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
828 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
829 # surprise- we are already INSIDE virtualmake!!!
830 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
831 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
832 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
833 debug-print " kde4-base.eclass docs for details... Applying workaround."
834 cmake-utils_src_test
267 else 835 else
268 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 836 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
269 x11-libs/qt-core:4 debug 837 fi
270 x11-libs/qt-gui:4 debug 838 else
271 x11-libs/qt-qt3support:4 debug 839 cmake-utils_src_test
272 x11-libs/qt-svg:4 debug 840 fi
273 x11-libs/qt-test:4 debug" 841}
274 if [[ ${OPENGL_REQUIRED} == always ]] || has opengl ${IUSE//+} && use opengl; then 842
275 KDE4_BUILT_WITH_USE_CHECK="${KDE4_BUILT_WITH_USE_CHECK} 843# @FUNCTION: kde4-base_src_install
276 x11-libs/qt-opengl:4 debug" 844# @DESCRIPTION:
845# Function for installing KDE4 applications.
846kde4-base_src_install() {
847 debug-print-function ${FUNCNAME} "$@"
848
849 if [[ -n ${KMSAVELIBS} ]] ; then
850 install_library_dependencies
851 fi
852
853 # Install common documentation of KDE4 applications
854 local doc
855 if ! has kde4-meta ${INHERITED}; then
856 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
857 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
858 done
859 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
860 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
861 done
862 fi
863
864 cmake-utils_src_install
865
866 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
867 # because then khelpcenter can't find the docs
868 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
869 docompress -x ${PREFIX}/share/doc/HTML
870}
871
872# @FUNCTION: kde4-base_pkg_preinst
873# @DESCRIPTION:
874# Function storing icon caches
875kde4-base_pkg_preinst() {
876 debug-print-function ${FUNCNAME} "$@"
877
878 gnome2_icon_savelist
879}
880
881# @FUNCTION: kde4-base_pkg_postinst
882# @DESCRIPTION:
883# Function to rebuild the KDE System Configuration Cache after an application has been installed.
884kde4-base_pkg_postinst() {
885 debug-print-function ${FUNCNAME} "$@"
886
887 gnome2_icon_cache_update
888 fdo-mime_desktop_database_update
889 fdo-mime_mime_database_update
890 buildsycoca
891
892 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
893 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
894 echo
895 ewarn "WARNING! you have kdeenable final useflag enabled."
896 ewarn "This useflag needs to be enabled on ALL kde using packages and"
897 ewarn "is known to cause issues."
898 ewarn "You are using this setup at your own risk and the kde team does not"
899 ewarn "take responsibilities for dead kittens."
900 echo
901 fi
902 if [[ ${BUILD_TYPE} = live ]]; then
903 echo
904 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
905 einfo "Use it at your own risk."
906 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
907 echo
908 fi
909 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
910 if [[ ${KDEBASE} != kde-base ]] && \
911 ! has_version 'kde-base/kdebase-runtime-meta' && \
912 ! has_version 'kde-base/kdebase-startkde'; then
913 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
914 echo
915 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
916 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
917 ewarn "With this setting you are unsupported by KDE team."
918 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
277 fi 919 fi
278 fi 920 fi
279 fi 921 fi
280
281 if [[ ${OPENGL_REQUIRED} == always ]] || has opengl ${IUSE//+} && use opengl; then
282 if has_version '<x11-libs/qt-4.4.0_alpha:4'; then
283 QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} opengl"
284 fi
285 fi
286
287 kde4-functions_check_use
288}
289
290# @FUNCTION: kde4-base_apply_patches
291# @DESCRIPTION:
292# This function applies patches.
293#
294# If the directory ${WORKDIR}/patches/ exists, we apply all patches in that
295# directory, provided they follow this format:
296# @CODE
297# - Monolithic ebuilds, (from kde-base)
298# - $CATEGORY=kde-base:
299# Apply ${CHILD_EBUILD_NAME}-${SLOT}-*{diff,patch}
300# - $CATEGORY=!kde-base:
301# Apply ${CHILD_EBUILD_NAME}-${PV}-*{diff,patch}
302# - Split ebuilds:
303# - $CATEGORY=kde-base:
304# Apply ${PN}-${SLOT}-*{diff,patch}
305# - $CATEGORY!=kde-base:
306# Apply ${PN}-${PV}-*{diff,patch}
307# @CODE
308#
309# If ${PATCHES} is non-zero all patches in it gets applied.
310kde4-base_apply_patches() {
311 local _patchdir _packages _p
312 _patchdir="${WORKDIR}/patches/"
313 if [[ -d "${_patchdir}" ]]; then
314 if is-parent-package ${CATEGORY}/${PN} ; then
315 _packages="$(get-child-packages ${CATEGORY}/${PN})"
316 _packages="${_packages//${CATEGORY}\//} ${PN}"
317 else
318 _packages="${PN}"
319 fi
320 for _p in ${_packages}; do
321 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${PV}-*{diff,patch} 2>/dev/null)"
322 if [[ -n "${KDEBASE}" ]]; then
323 PATCHES="${PATCHES} $(ls ${_patchdir}/${_p}-${SLOT}-*{diff,patch} 2>/dev/null)"
324 fi
325 done
326 fi
327 [[ -n ${PATCHES} ]] && base_src_unpack autopatch
328}
329
330# @FUNCTION: kde4-base_src_unpack
331# @DESCRIPTION:
332# This function unpacks the source tarballs for KDE4 applications.
333#
334# If no argument is passed to this function, then standard src_unpack is
335# executed. Otherwise options are passed to base_src_unpack.
336#
337# In addition it calls kde4-base_apply_patches when no arguments are passed to
338# this function.
339kde4-base_src_unpack() {
340 debug-print-function $FUNCNAME "$@"
341
342 [[ -z "${KDE_S}" ]] && KDE_S="${S}"
343
344 if [[ -z $* ]]; then
345 # Unpack first and deal with KDE patches after examing possible patch sets.
346 # To be picked up, patches need to conform to the guidelines stated before.
347 # Monolithic ebuilds will use the split ebuild patches.
348 [[ -d "${KDE_S}" ]] || unpack ${A}
349 kde4-base_apply_patches
350 else
351 # Call base_src_unpack, which unpacks and patches
352 # step by step transparently as defined in the ebuild.
353 base_src_unpack $*
354 fi
355
356 # Updated cmake dir
357 if [[ -d "${WORKDIR}/cmake" ]] && [[ -d "${KDE_S}/cmake" ]]; then
358 ebegin "Updating cmake/ directory..."
359 rm -rf "${KDE_S}/cmake" || die "Unable to remove old cmake/ directory"
360 ln -s "${WORKDIR}/cmake" "${KDE_S}/cmake" || die "Unable to symlink the new cmake/ directory"
361 eend 0
362 fi
363}
364
365# @FUNCTION: kde4-base_src_compile
366# @DESCRIPTION:
367# General function for compiling KDE4 applications.
368kde4-base_src_compile() {
369 debug-print-function ${FUNCNAME} "$@"
370
371 kde4-base_src_configure
372 kde4-base_src_make
373}
374
375# @FUNCTION: kde4-base_src_configure
376# @DESCRIPTION:
377# Function for configuring the build of KDE4 applications.
378kde4-base_src_configure() {
379 debug-print-function ${FUNCNAME} "$@"
380
381 # Final flag handling
382 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
383 einfo "Activating enable-final flag"
384 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_FINAL=ON"
385 fi
386
387 # Enable generation of HTML handbook
388 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then
389 einfo "Enabling building of HTML handbook"
390 mycmakeargs="${mycmakeargs} -DKDE4_ENABLE_HTMLHANDBOOK=ON"
391 fi
392
393 # Build tests in src_test only, where we override this value
394 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=OFF"
395
396 # Set distribution name
397 [[ ${PN} == "kdelibs" ]] && mycmakeargs="${mycmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo"
398
399 # runpath linking
400 mycmakeargs="${mycmakeargs} -DKDE4_USE_ALWAYS_FULL_RPATH=ON"
401
402 # Here we set the install prefix
403 mycmakeargs="${mycmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}"
404
405 # Set environment
406 QTEST_COLORED=1
407 QT_PLUGIN_PATH=${KDEDIR}/$(get_libdir)/kde4/plugins/
408
409 cmake-utils_src_configureout
410}
411
412# @FUNCTION: kde4-base_src_make
413# @DESCRIPTION:
414# Function for building KDE4 applications.
415# Options are passed to cmake-utils_src_make.
416kde4-base_src_make() {
417 debug-print-function ${FUNCNAME} "$@"
418
419 cmake-utils_src_make "$@"
420}
421
422# @FUNCTION: kde4-base_src_test
423# @DESCRIPTION:
424# Function for testing KDE4 applications.
425kde4-base_src_test() {
426 debug-print-function ${FUNCNAME} "$@"
427
428 # Override this value, set in kde4-base_src_configure()
429 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON"
430 cmake-utils_src_compile
431
432 cmake-utils_src_test
433}
434
435# @FUNCTION: kde4-base_src_install
436# @DESCRIPTION:
437# Function for installing KDE4 applications.
438kde4-base_src_install() {
439 debug-print-function ${FUNCNAME} "$@"
440
441 kde4-base_src_make_doc
442 cmake-utils_src_install
443}
444
445# @FUNCTION: kde4-base_src_make_doc
446# @DESCRIPTION:
447# Function for installing the documentation of KDE4 applications.
448kde4-base_src_make_doc() {
449 debug-print-function ${FUNCNAME} "$@"
450
451 local doc
452 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
453 [[ -s $doc ]] && dodoc ${doc}
454 done
455
456 if [[ -z ${KMNAME} ]]; then
457 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
458 if [[ -s $doc ]]; then
459 local doc_complete=${doc}
460 doc="${doc#*/}"
461 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
462 fi
463 done
464 fi
465
466 if [[ -n ${KDEBASE} && -d "${D}"/usr/share/doc/${PF} ]]; then
467 # work around bug #97196
468 dodir /usr/share/doc/kde && \
469 mv "${D}"/usr/share/doc/${PF} "${D}"/usr/share/doc/kde/ || \
470 die "Failed to move docs to kde/ failed."
471 fi
472}
473
474# @FUNCTION: kde4-base_pkg_postinst
475# @DESCRIPTION:
476# Function to rebuild the KDE System Configuration Cache after an application has been installed.
477kde4-base_pkg_postinst() {
478 buildsycoca
479} 922}
480 923
481# @FUNCTION: kde4-base_pkg_postrm 924# @FUNCTION: kde4-base_pkg_postrm
482# @DESCRIPTION: 925# @DESCRIPTION:
483# Function to rebuild the KDE System Configuration Cache after an application has been removed. 926# Function to rebuild the KDE System Configuration Cache after an application has been removed.
484kde4-base_pkg_postrm() { 927kde4-base_pkg_postrm() {
928 debug-print-function ${FUNCNAME} "$@"
929
930 gnome2_icon_cache_update
931 fdo-mime_desktop_database_update
932 fdo-mime_mime_database_update
485 buildsycoca 933 buildsycoca
486} 934}

Legend:
Removed from v.1.4  
changed lines
  Added in v.1.108

  ViewVC Help
Powered by ViewVC 1.1.20